{****************************
 *                          *
 * Autor: Adrian M. Hanslik *
 * Date 06. June 1999       *
 * Version: 1.0             *
 *                          *
 ****************************}

unit AMHTrafficLBMP;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TState = (sAll, sAmber, sGreen, sNone, sRed, sRedAmber);

  TAMHTrafficLBMP = class(TGraphicControl)
  private
    { Private-Deklarationen }
    fBitmapAll: TBitmap;
    fBitmapAmber: TBitmap;
    fBitmapGreen: TBitmap;
    fBitmapNone: TBitmap;
    fBitmapRed: TBitmap;
    fBitmapRedAmber: TBitmap;
    fState: TState;
    procedure SetBitmapAll(Value: TBitmap);
    procedure SetBitmapAmber(Value: TBitmap);
    procedure SetBitmapGreen(Value: TBitmap);
    procedure SetBitmapNone(Value: TBitmap);
    procedure SetBitmapRed(Value: TBitmap);
    procedure SetBitmapRedAmber(Value: TBitmap);
    procedure SetState(Value: TState);
  protected
    { Protected-Deklarationen }
    procedure Paint; override;
  public
    { Public-Deklarationen }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    { Published-Deklarationen }
    property BitmapAll: TBitmap read fBitmapAll write SetBitmapAll;
    property BitmapAmber: TBitmap read fBitmapAmber write SetBitmapAmber;
    property BitmapGreen: TBitmap read fBitmapGreen write SetBitmapGreen;
    property BitmapNone: TBitmap read fBitmapNone write SetBitmapNone;
    property BitmapRed: TBitmap read fBitmapRed write SetBitmapRed;
    property BitmapRedAmber: TBitmap read fBitmapRedAmber write SetBitmapRedAmber;
    property State: TState read fState write SetState;
  end;

implementation

constructor TAMHTrafficLBMP.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  fBitmapAll := TBitmap.Create;
  fBitmapAmber := TBitmap.Create;
  fBitmapGreen := TBitmap.Create;
  fBitmapNone := TBitmap.Create;
  fBitmapRed := TBitmap.Create;
  fBitmapRedAmber := TBitmap.Create;
  Height := fBitmapRed.Height;
  Width := fBitmapRed.Width;
  fState := sRed;
end;

destructor TAMHTrafficLBMP.Destroy;
begin
  fBitmapAll.Free;
  fBitmapAmber.Free;
  fBitmapGreen.Free;
  fBitmapNone.Free;
  fBitmapRed.Free;
  fBitmapRedAmber.Free;
  inherited Destroy;
end;

procedure TAMHTrafficLBMP.Paint;
begin
  with Canvas do begin
       if fState = sAll then
          Draw(0, 0, fBitmapAll);
       if fState = sAmber then
          Draw(0, 0, fBitmapAmber);
       if fState = sGreen then
          Draw(0, 0, fBitmapGreen);
       if fState = sNone then
          Draw(0, 0, fBitmapNone);
       if fState = sRed then
          Draw(0, 0, fBitmapRed);
       if fState = sRedAmber then
          Draw(0, 0, fBitmapRedAmber);
  end;
end;

procedure TAMHTrafficLBMP.SetBitmapAll(Value: TBitmap);
begin
  fBitmapAll.Assign(Value);
end;

procedure TAMHTrafficLBMP.SetBitmapAmber(Value: TBitmap);
begin
  fBitmapAmber.Assign(Value);
end;

procedure TAMHTrafficLBMP.SetBitmapGreen(Value: TBitmap);
begin
  fBitmapGreen.Assign(Value);
end;

procedure TAMHTrafficLBMP.SetBitmapNone(Value: TBitmap);
begin
  fBitmapNone.Assign(Value);
end;

procedure TAMHTrafficLBMP.SetBitmapRed(Value: TBitmap);
begin
  fBitmapRed.Assign(Value);
end;

procedure TAMHTrafficLBMP.SetBitmapRedAmber(Value: TBitmap);
begin
  fBitmapRedAmber.Assign(Value);
end;

procedure TAMHTrafficLBMP.SetState(Value: TState);
begin
  if Value <> fState then begin
     fState := Value;
     Invalidate;
  end;
end;

end.
